port    equ $02 ; Port C
DIR     equ $06 ;PortCdir
dt      equ 0   ;Port  9 = RAM-Datenleitung
sh      equ 1   ;Port 10 = RAM-Shift-Clock
st      equ 2   ;Port 11 = RAM-Store-Clock
we      equ 7   ;Port 16 = RAM-Write-Enable

dtas    equ 1   ;Port 10 = SRLCD-Datenleitung
shclk   equ 0   ;Port  9 = SRLCD-Shift-Clock
stclk   equ 3   ;Port 12 = SRCLD-Store-Clock
ReadEEByte equ $0e04 


i2c_start equ $083C
i2c_write equ $0846
i2c_read  equ $086F
i2c_readlast equ $08BB
i2c_stop  equ $08E5
PCFD      equ 78
PCFDr     equ 79
Control   equ $a1 ; Control-Register (= Basic-Byte 1)
          ;RAM-Interf.Ports:<LSB> A16(bit16),CS0,1,2,3 <MSB>

; 91,92 = Wert; 93,94 = 16bit Addr(bit0 bis bit15)

        org $101
writew  bsr rdlast ; Word schreiben
        bsr writeRAM ;hi-word
        bset 0,$94 ; Bit setzen fr lo-word-Adresse(ungerade)
        bra NBw    ; lo-word

writeb  bsr rdlast ; Byte schreiben
NBw     lda $92
        sta $91
        bsr writeRAM
        bra coneeprom

readb   bsr readmod ; Byte lesen
        clr $91
        bra coneeprom

readw   bsr readmod ; Word lesen hi-word
        bset 0,$94 ; Bit setzen fr lo-word-Adresse
        lda $92
        sta $91
        bsr readRAM ; lo-word
coneeprom ;EEProm anmelden
        ldx #$0A0
        bsr i2cstart
        ldx $066
        jsr i2c_write
        ldx $067
        jsr i2c_write
        ldx #$0A1
i2cstart
        jsr i2c_start
        rts
       
readmod bsr rdlast ; Data-PCF8574 als Eingang
        ldx #PCFD
        bsr i2cstart
        ldx #$FF
        bsr wrlast
readRAM
        bset we,port
        bsr setaddr
        ldx #PCFDr
rdb     bsr i2cstart
        jsr i2c_read
        sta $92
rdlast  jsr i2c_readlast
        rts

wrlast  jsr i2c_write
        jsr i2c_stop
        rts

writeRAM
        ldx #PCFD
        bsr i2cstart
        ldx $91
        bsr wrlast
        bsr setaddr
setAW   bclr we,port ;Write enable-pulse
        bset we,port 
        rts



setaddr lda Control
        jsr Put8B
        lda $93
        jsr Put8B
        lda $94
        jsr Put8B
Str     bset st,port ;Send RAM Store Clock
        bclr st,port
        rts

Put8B   ldx #8 ;states in a
NextB   rola
        bcc LoB
        bset dt,port
        bra PutClk
LoB     bclr dt,port
PutClk  jsr Clk
        decx
        bne NextB
        rts        
        
Clk     bset sh,port ;Send Shift Clock
        bclr sh,port
        rts

;SRLCD-Routinen

send    lda $92
        jsr Put8Bit
        lda $94 
        jsr Put8Bit
        jsr Store
        jsr LOW
        rts
        
Put8Bit ldx #8
NextBit rola
        bcc LoBit
        bset dtas,port
        bra PutlClk
LoBit   bclr dtas,port
PutlClk jsr Clock
        decx
        bne NextBit
        rts        
        
Clock   bset shclk,port ;Send Shift Clock
        bclr shclk,port
        rts

Store   bset stclk,port ;Send Store Clock
        bclr stclk,port
        rts

LOW     bclr shclk,port ;ersten 10-SR(LCD)-Ports auf Low
        bclr stclk,port ;letzten 6-SR(out)-Ports nach $92 setzen bit(2-7)
        lda $92
        ldx #6
NB      rola
        bcc LB
        bset dtas,port
        bra PC
LB      bclr dtas,port
PC      jsr Clock
        decx
        bne NB        
        bclr dtas,port
        ldx #10
Nextclk jsr Clock 
        decx
        bne Nextclk
        jsr Store
        rts
print:
	jsr ReadEEByte
	bra getchar
printchar:
        jsr send
getchar:
	jsr ReadEEByte
	sta $94
	bne printchar
	rts         
        
        
        